import React, { memo } from 'react';
import { View } from '@ray-js/ray';
import { useProps, useActions } from '@ray-js/panel-sdk';

import styles from './index.module.less';
import Colour from '../colour/index';

const list = [
  {
    name: '彩光',
    id: 'colour',
  },
  {
    name: '白光',
    id: 'white',
  },
];

const RGB = () => {
  const dpaction = useActions();
  const workMode = useProps(props => props.work_mode);

  /**
   * @desc 切换工作模式
   * @param {string} id
   */
  const handleChangeWorkMode = (id: string) => {
    if (workMode === id) return;
    dpaction.work_mode.set(id, { throttle: 300 });
  };
  return (
    <View className={styles.RGB}>
      <View className={styles.RGBTagbar}>
        {list.map(item => (
          <View
            key={item.id}
            className={styles.item + ' ' + (workMode === item.id ? styles.current : '')}
            onClick={() => {
              handleChangeWorkMode(item.id);
            }}
          >
            {item.name}
          </View>
        ))}
      </View>
      <Colour />
    </View>
  );
};

export default memo(RGB);
