import React, { memo, useState, useEffect } from 'react';
import { View } from '@ray-js/ray';
import { useProps, useActions } from '@ray-js/panel-sdk';

import { LampCirclePickerColor } from '@ray-js/components-ty-lamp';

import styles from './index.module.less';

const Colour = () => {
  const [hs, setHS] = useState({ h: 36, s: 500 });

  useEffect(() => {
    setTimeout(() => {
      setHS({
        h: 100,
        s: 1000,
      });
    }, 1000);
  }, []);

  const handleTouchStart = (hsRes: any) => {
    setHS(hsRes);
  };
  const handleTouchMove = (hsRes: any) => {
    console.log(hsRes, 'handleTouchMove');
    // setHS(hsRes);
  };
  const handleTouchEnd = (hsRes: any) => {
    // console.log(hsRes, 'handleTouchEnd');
    setHS(hsRes);
  };
  return (
    <View className={styles.colour}>
      <LampCirclePickerColor
        hs={hs}
        thumbRadius={15}
        radius={140}
        whiteRange={0.15}
        onTouchStart={handleTouchStart}
        onTouchEnd={handleTouchEnd}
        onTouchMove={handleTouchMove}
      />
    </View>
  );
};

export default memo(Colour);
